/*
 * This file is part of the AdvanceMAME project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#include "vgatweak.h"

#include <stdlib.h>
#include <stdio.h>

vgatweak_video_mode tweak_13_default = {
	0x13,
	25, /* CHECK */
	{
		{ 0x3c2, 0x0, 0x63 },
		{ 0x3d4, 0x0, 0x5f },
		{ 0x3d4, 0x1, 0x4f },
		{ 0x3d4, 0x2, 0x50 },
		{ 0x3d4, 0x3, 0x82 },
		{ 0x3d4, 0x4, 0x54 },
		{ 0x3d4, 0x5, 0x80 },
		{ 0x3d4, 0x6, 0xbf },
		{ 0x3d4, 0x7, 0x1f },
		{ 0x3d4, 0x8, 0x0 },
		{ 0x3d4, 0x9, 0x41 },
		{ 0x3d4, 0x10, 0x9c },
		{ 0x3d4, 0x11, 0x9e }, // (0x8e on S3)
		{ 0x3d4, 0x12, 0x8f },
		{ 0x3d4, 0x13, 0x28 },
		{ 0x3d4, 0x14, 0x40 }, // dword mode
		{ 0x3d4, 0x15, 0x96 },
		{ 0x3d4, 0x16, 0x79 }, // (0xb9 on S3)
		{ 0x3d4, 0x17, 0xa3 }, // word mode
		{ 0x3c4, 0x1, 0x1 },
		{ 0x3c4, 0x4, 0xe },
		{ 0x3ce, 0x5, 0x40 },
		{ 0x3ce, 0x6, 0x5 },
		{ 0x3c0, 0x10, 0x41 },
		{ 0x3c0, 0x13, 0x0 }
	}
};

/*
 * plz  freq dsen blst rtst rten blen totl ch type pclock scan
 * h+         400  400  428  492  520  528  8 grph         100
 * v+         300  299  300  302  384  314  2 blank8bit
 */

vgatweak_video_mode tweak_6A_default = {
	0x6A,
	25, /* CHECK */
	{
		{ 0x3c2, 0x0, 0x2f },
		{ 0x3d4, 0x0, 0x7f },
		{ 0x3d4, 0x1, 0x63 },
		{ 0x3d4, 0x2, 0x64 },
		{ 0x3d4, 0x3, 0x82 },
		{ 0x3d4, 0x4, 0x6b },
		{ 0x3d4, 0x5, 0x1b },
		{ 0x3d4, 0x6, 0x72 },
		{ 0x3d4, 0x7, 0xf0 },
		{ 0x3d4, 0x8, 0x0 },
		{ 0x3d4, 0x9, 0x61 },
		{ 0x3d4, 0x10, 0x58 },
		{ 0x3d4, 0x11, 0x8c },
		{ 0x3d4, 0x12, 0x57 },
		{ 0x3d4, 0x13, 0x32 },
		{ 0x3d4, 0x14, 0x0 },
		{ 0x3d4, 0x15, 0x57 },
		{ 0x3d4, 0x16, 0x0 },
		{ 0x3d4, 0x17, 0xe3 },
		{ 0x3c4, 0x1, 0x1 },
		{ 0x3c4, 0x4, 0x6 },
		{ 0x3ce, 0x5, 0x40 },
		{ 0x3ce, 0x6, 0x5 },
		{ 0x3c0, 0x10, 0x41 },
		{ 0x3c0, 0x13, 0x0 }
	}
};

vgatweak_video_mode tweak_3_default = {
	0x3,
	25, /* CHECK */
	{
		{ 0x3c2, 0x0, 0x67 },
		{ 0x3d4, 0x0, 0x5f },
		{ 0x3d4, 0x1, 0x4f },
		{ 0x3d4, 0x2, 0x50 },
		{ 0x3d4, 0x3, 0x82 },
		{ 0x3d4, 0x4, 0x55 },
		{ 0x3d4, 0x5, 0x81 },
		{ 0x3d4, 0x6, 0xbf },
		{ 0x3d4, 0x7, 0x1f },
		{ 0x3d4, 0x8, 0x0 },
		{ 0x3d4, 0x9, 0x4f },
		{ 0x3d4, 0x10, 0x9c },
		{ 0x3d4, 0x11, 0x8e },
		{ 0x3d4, 0x12, 0x8f },
		{ 0x3d4, 0x13, 0x28 },
		{ 0x3d4, 0x14, 0x1f }, // NOT dword mode
		{ 0x3d4, 0x15, 0x96 },
		{ 0x3d4, 0x16, 0xb9 },
		{ 0x3d4, 0x17, 0xa3 }, // word mode
		{ 0x3c4, 0x1, 0x0 },
		{ 0x3c4, 0x4, 0x2 },
		{ 0x3ce, 0x5, 0x10 },
		{ 0x3ce, 0x6, 0xe },
		{ 0x3c0, 0x10, 0xc },
		{ 0x3c0, 0x13, 0x8 }
	}
};

vgatweak_video_mode tweak_1_default = {
	0x1,
	25, /* CHECK */
	{
	{ 0x3c2, 0x0, 0x67 },
	{ 0x3d4, 0x0, 0x2d },
	{ 0x3d4, 0x1, 0x27 },
	{ 0x3d4, 0x2, 0x28 },
	{ 0x3d4, 0x3, 0x90 },
	{ 0x3d4, 0x4, 0x2b },
	{ 0x3d4, 0x5, 0xa0 },
	{ 0x3d4, 0x6, 0xbf },
	{ 0x3d4, 0x7, 0x1f },
	{ 0x3d4, 0x8, 0x0 },
	{ 0x3d4, 0x9, 0x4f },
	{ 0x3d4, 0x10, 0x9c },
	{ 0x3d4, 0x11, 0x8e },
	{ 0x3d4, 0x12, 0x8f },
	{ 0x3d4, 0x13, 0x14 },
	{ 0x3d4, 0x14, 0x1f },
	{ 0x3d4, 0x15, 0x96 },
	{ 0x3d4, 0x16, 0xb9 },
	{ 0x3d4, 0x17, 0xa3 },
	{ 0x3c4, 0x1, 0x8 },
	{ 0x3c4, 0x4, 0x2 },
	{ 0x3ce, 0x5, 0x10 },
	{ 0x3ce, 0x6, 0xe },
	{ 0x3c0, 0x10, 0xc },
	{ 0x3c0, 0x13, 0x8 }
	}
};

int vgatweak_mode_set(vgatweak_video_mode* mode) {
	video_log("vgatweak: mode_set %x\n",mode->mode);

	if (vga_mode_set(mode->mode,mode->regs,mode->regs_num)!=0) {
		return -1;
	}

	return 0;
}

void vgatweak_mode_done(void) {
	vga_mode_done();
}

int vgatweak_mode_grab(vgatweak_video_mode* mode) {
	if (!vga_active())
		return -1;

	if (vga_mode_grab(&mode->mode,mode->regs,&mode->regs_num,VIDEO_MODE_REGS_MAX)!=0)
		return -1;

	return 0;
}

/* Import information for one video mode
	mode->tweak video mode
	Return 0 if successful
*/
int vgatweak_mode_import_ext(video_mode* mode,vgatweak_video_mode* driver) {
	struct tweak_crtc info;
	tweak_crtc_get(&info,tweak_register_get, driver);

	if (info.is_graphics_mode && info.bits_per_pixel!=8) {
		video_error_description_set("Not a 8 bit mode");
		return -1;
	}

	mode->flags = VIDEO_FLAGS_DRIVER_VGATWEAK |
		VIDEO_FLAGS_ASYNC_SETPAGE |
		(mode->flags & VIDEO_FLAGS_USER_MASK);

	if (info.is_linear)
		mode->flags |= VIDEO_FLAGS_LINEAR;

	if (!info.is_graphics_mode) {
		mode->flags |= VIDEO_FLAGS_TYPE_TEXT | VIDEO_FLAGS_INDEX_TEXT;
		mode->bits = 0;
	} else {
		mode->flags |= VIDEO_FLAGS_TYPE_GRAPHICS | VIDEO_FLAGS_INDEX_PACKED;
		mode->bits = 8;
	}
	mode->size_x = info.size_x;
	mode->size_y = info.size_y;
	mode->virtual_x = info.virtual_x;
	mode->virtual_y = info.virtual_y;
	mode->vert_freq = info.vert_clock;
	mode->horz_freq = info.horz_clock;

#if 0
	/* euristic */
	mode->aspect_x = info.horz_display_end * info.vert_total;
	mode->aspect_y = info.vert_display_end * info.horz_total;
#else
	mode->aspect_x = 4 * mode->size_y;
	mode->aspect_y = 3 * mode->size_x;
#endif

	return 0;
}

int vgatweak_mode_import(video_mode* mode) {
	return vgatweak_mode_import_ext(mode,&mode->driver.vgatweak);
}

/* Default register for vga mode 13h 320x200 256 color */
static tweak_register tweak_vga320x200[] = {
	{ 0x3c2, 0x0, 0x63 },
	{ 0x3d4, 0x0, 0x5f },
	{ 0x3d4, 0x1, 0x4f },
	{ 0x3d4, 0x2, 0x50 },
	{ 0x3d4, 0x3, 0x82 },
	{ 0x3d4, 0x4, 0x54 },
	{ 0x3d4, 0x5, 0x80 },
	{ 0x3d4, 0x6, 0xbf },
	{ 0x3d4, 0x7, 0x1f },
	{ 0x3d4, 0x8, 0x0 },
	{ 0x3d4, 0x9, 0x41 },
	{ 0x3d4, 0x10, 0x9c },
	{ 0x3d4, 0x11, 0x8e },
	{ 0x3d4, 0x12, 0x8f },
	{ 0x3d4, 0x13, 0x28 },
	{ 0x3d4, 0x14, 0x40 },
	{ 0x3d4, 0x15, 0x96 },
	{ 0x3d4, 0x16, 0xb9 },
	{ 0x3d4, 0x17, 0xa3 },
	{ 0x3c4, 0x1, 0x1 },
//      { 0x3c4, 0x3, 0x0 },
	{ 0x3c4, 0x4, 0xe },
	{ 0x3ce, 0x5, 0x40 },
	{ 0x3ce, 0x6, 0x5 },
	{ 0x3c0, 0x10, 0x41 },
//      { 0x3c0, 0x11, 0x0 },
//      { 0x3c0, 0x12, 0xf },
	{ 0x3c0, 0x13, 0x0 },
//      { 0x3c0, 0x14, 0x0 }
};

/* Default register for vga mode 6Ah 800x600 16 color */
static tweak_register tweak_vga800x600[] = {
	{ 0x3c2, 0x0, 0x2f },
	{ 0x3d4, 0x0, 0x7f },
	{ 0x3d4, 0x1, 0x63 },
	{ 0x3d4, 0x2, 0x64 },
	{ 0x3d4, 0x3, 0x82 },
	{ 0x3d4, 0x4, 0x6b },
	{ 0x3d4, 0x5, 0x1b },
	{ 0x3d4, 0x6, 0x72 },
	{ 0x3d4, 0x7, 0xf0 },
	{ 0x3d4, 0x8, 0x0 },
	{ 0x3d4, 0x9, 0x60 },
	{ 0x3d4, 0x10, 0x58 },
	{ 0x3d4, 0x11, 0x8c },
	{ 0x3d4, 0x12, 0x57 },
	{ 0x3d4, 0x13, 0x32 },
	{ 0x3d4, 0x14, 0x0 },
	{ 0x3d4, 0x15, 0x57 },
	{ 0x3d4, 0x16, 0x0 },
	{ 0x3d4, 0x17, 0xe3 },
	{ 0x3c4, 0x1, 0x1 },
//      { 0x3c4, 0x3, 0x0 },
	{ 0x3c4, 0x4, 0x6 },
	{ 0x3ce, 0x5, 0x0 },
	{ 0x3ce, 0x6, 0x5 },
	{ 0x3c0, 0x10, 0x1 },
//      { 0x3c0, 0x11, 0x0 },
//      { 0x3c0, 0x12, 0xf },
	{ 0x3c0, 0x13, 0x0 },
//      { 0x3c0, 0x14, 0x0 }
};

unsigned tweak_register_get(unsigned port, int subindex, void* arg) {
	vgatweak_video_mode* tweak = (vgatweak_video_mode*)arg;
	unsigned i;
	tweak_register* r = 0;
	unsigned r_num = 0;

	/* specific register */
	for(i=0;i<tweak->regs_num;++i)
		if (tweak->regs[i].port == port && (subindex<0 || tweak->regs[i].index == subindex))
			return tweak->regs[i].value;

	/* default register */
	if (tweak->mode == 0x13) {
		r = tweak_vga320x200;
		r_num = sizeof(tweak_vga320x200)/sizeof(tweak_register);
	} else if (tweak->mode == 0x6A) {
		r = tweak_vga800x600;
		r_num = sizeof(tweak_vga800x600)/sizeof(tweak_register);
	}

	if (r) {
		for(i=0;i<r_num;++i)
			if (r[i].port == port && (subindex<0 || r[i].index == subindex))
				return r[i].value;
	}

	return 0;
}

int tweak_register_set(unsigned value, unsigned port, int subindex, void* arg) {
	vgatweak_video_mode* tweak = (vgatweak_video_mode*)arg;
	unsigned i;

	/* register already present */
	for(i=0;i<tweak->regs_num;++i) {
		if (tweak->regs[i].port == port && (subindex<0 || tweak->regs[i].index == subindex)) {
			tweak->regs[i].value = value;
			return 0;
		}
	}

	/* add register */
	if (tweak->regs_num < VIDEO_MODE_REGS_MAX) {
		tweak->regs[tweak->regs_num].index = subindex;
		tweak->regs[tweak->regs_num].port = port;
		tweak->regs[tweak->regs_num].value = value;
		++tweak->regs_num;
		return 0;
	}

	return -1;
}

/* Default tweak mode */
#define TWEAK_MODE(n,r) { n, sizeof(r)/sizeof(tweak_register), r },

static struct vgatweak_default_struct {
	const char* name;
	unsigned regs_num;
	tweak_register* regs;
} vgatweak_default[] = {
	TWEAK_MODE( "tweak320x200", tweak_vga320x200 ) // VGA mode 13h
	{ 0, 0, 0 }
};

video_error vgatweak_mode_import_and_insert(video_mode_container* vmc, video_mode* mode) {
	video_mode mode8 = *mode;
	if (video_mode_import(&mode8)==0) {
		video_mode_container_insert(vmc,&mode8);
	}
	return 0;
}

void video_mode_container_insert_vgatweak(video_mode_container* vmc) {
	struct vgatweak_default_struct* p = vgatweak_default;
	while (p->name) {
		unsigned i;
		video_mode v;
		memset(&v,0,sizeof(v));
		assert( p->regs_num <= VIDEO_MODE_REGS_MAX );
		v.driver.vgatweak.mode = 0x13;
		v.driver.vgatweak.regs_num = p->regs_num;
		for(i=0;i<p->regs_num;++i)
			v.driver.vgatweak.regs[i] = p->regs[i];
		if (vgatweak_mode_import(&v)==0) {
			assert( strlen(p->name) < VIDEO_MODE_NAME_MAX );
			strcpy(v.name,p->name);
			video_mode_container_insert(vmc,&v);
		}
		++p;
	}
}

#if 1
void video_mode_vgatweak_print(char* s, const video_mode* mode) {
	unsigned i;
	sprintf(s,"%s vgatweak(%x ", mode->name, mode->driver.vgatweak.mode);
	for(i=0;i<mode->driver.vgatweak.regs_num;++i) {
		sprintf(s+strlen(s),"%x[%x]=%x",
			(unsigned)mode->driver.vgatweak.regs[i].port,
			(unsigned)mode->driver.vgatweak.regs[i].index,
			(unsigned)mode->driver.vgatweak.regs[i].value);
		if (i+1!=mode->driver.vgatweak.regs_num)
			sprintf(s+strlen(s)," ");
	}
	sprintf(s+strlen(s),")");
}

#else

/* Export in vgaline format */
void video_mode_vgatweak_print(char* s, const video_mode* mode) {
	tweak_mode_info info;
	const char* flag1;
	const char* flag2;
	const char* flag3;
	tweak_detect_mode(&info, tweak_register_get, (void*)&mode->driver.vgatweak);
	flag1 = info.char_size_y>1 ? " doublescan" : "";
	flag2 = info.hsync ? " -hsync" : " +hsync";
	flag3 = info.vsync ? " -vsync" : " +vsync";
	sprintf(s,"%s vgaline(%x %.2f %d %d %d %d %d %d %d %d%s%s%s)",
		mode->name, mode->driver.vgatweak.mode, (double)info.dot_clock/2E6,
		info.horz_display_end*info.horz_pixel_per_clock, info.horz_retrace_start*info.horz_pixel_per_clock, info.horz_retrace_end*info.horz_pixel_per_clock, info.horz_total*info.horz_pixel_per_clock,
		info.vert_display_end/info.char_size_y, info.vert_retrace_start/info.char_size_y, info.vert_retrace_end/info.char_size_y, info.vert_total/info.char_size_y,
		flag1,flag2,flag3
	);
}
#endif

